"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.uniq = function (array) { return Array.from(new Set(array)); };
exports.hex2rgb = function (hex) {
    if (hex.slice(0, 1) === "#")
        hex = hex.slice(1);
    if (hex.length === 3)
        hex =
            hex.slice(0, 1) +
                hex.slice(0, 1) +
                hex.slice(1, 2) +
                hex.slice(1, 2) +
                hex.slice(2, 3) +
                hex.slice(2, 3);
    return [hex.slice(0, 2), hex.slice(2, 4), hex.slice(4, 6)].map(function (str) {
        return parseInt(str, 16);
    });
};
exports.mm2pt = function (mm) {
    // https://www.ddc.co.jp/words/archives/20090701114500.html
    var ptRatio = 2.8346;
    return parseFloat(String(mm)) * ptRatio;
};
exports.calcX = function (x, alignment, boxWidth, textWidth) {
    var addition = 0;
    if (alignment === "center") {
        addition = (boxWidth - textWidth) / 2;
    }
    else if (alignment === "right") {
        addition = boxWidth - textWidth;
    }
    return exports.mm2pt(x) + addition;
};
exports.calcY = function (y, height, itemHeight) {
    return height - exports.mm2pt(y) - itemHeight;
};
//# sourceMappingURL=util.js.map